<?php

// 
// WKT to KML Functionality was taken from http://bmoregeo.com/
//


// Parse WKT POINT to KML Point
function parsePoint($shape){
	$kml = '<Point><coordinates>' . $shape . '</coordinates></Point>';
	return $kml;
}

function parseLineString($shape){
$kml = '<LineString>'
. '<extrude>0</extrude>'
. '<tessellate>1</tessellate>'
. '<coordinates>' . substr($shape, 0) . '</coordinates>'
. '</LineString>';
return $kml;
}


function parsePolygon($shape){
$boundary = explode(') (', $shape);
$kml .= '<Polygon>'
. '<outerBoundaryIs><LinearRing><coordinates>' . $boundary[0] . '</coordinates></LinearRing></outerBoundaryIs>';
for ($i=1; $i < count($boundary); $i++) {
$kml .= '<innerBoundaryIs><LinearRing><coordinates>' . $boundary[$i] . '</coordinates></LinearRing></innerBoundaryIs>';
}
$kml .= '</Polygon>';
return $kml;
}

function getGeo($shape){
// Parse WKT style coordinates to KML style Coordinates
if(substr($shape, 0,3) != 'GEO'){$shape = preg_replace(array('/,/','/\s+/','/:/'),array(':',',',' '),$shape);}

switch(true){
case preg_match('/^POINT.ZM/', $shape):
$shape = substr($shape, 10,-1);
$kml = parsePoint($shape);
break;
case preg_match('/^POINT.M/', $shape):
$shape= substr($shape, 9, -1);
$kml = parsePoint($shape);
break;
case preg_match('/^POINT.Z/', $shape):
$shape= substr($shape, 9, -1);
$kml = parsePoint($shape);
break;
case preg_match('/^POINT\(/', $shape):
$shape = substr($shape, 6,-1);
$kml = parsePoint($shape);
break;
case preg_match('/^MULTIPOINT/', $shape):
$shape = substr($shape, 11,-2);
$points = explode(' ' ,$shape);
$kml = '<MultiGeometry>';
foreach($points as $point){$kml .= parsePoint($point);}
$kml .= '</MultiGeometry>';
break;
case preg_match('/^LINESTRING/', $shape):
$shape = substr($shape, 11, -1);
$kml = parseLineString($shape);
break;
case preg_match('/^MULTILINESTRING/', $shape):
$shape = substr($shape, 17, -2);
$linestrings = explode(') (', $shape);
$kml = '<MultiGeometry>';
foreach ($linestrings as $linestring) {$kml .= parseLineString($linestring);}
$kml .= '</MultiGeometry>';
break;
case preg_match('/^POLYGON/', $shape):
$shape = substr($shape, 9, -2);
$kml = parsePolygon($shape);
break;
case preg_match('/^MULTIPOLYGON/', $shape):
$shape = substr($shape, 15, -3);
$polygons = explode(')) ((', $shape);
$kml = '<MultiGeometry>';
foreach ($polygons as $polygon) {$kml .= parsePolygon($polygon);}
$kml .= '</MultiGeometry>';
break;
case preg_match('/^GEOMETRYCOLLECTION/',$shape):
$shape = substr($shape, 19, -2);
$multiGeometries = explode('),', $shape);
$kml = '<MultiGeometry>';
foreach ($multiGeometries as $multiGeometry) {$kml .= getGeo($multiGeometry . ')');}
$kml .= '</MultiGeometry>';
break;

}

return $kml;
}


//
// Author: Fernando Birra (fpb at di dot fct dot unl dot pt)
//

// You can start reading from here...
// In this simple example we will an xml file containing a set of <marker> elements inside a single <markers>
// XML generation should be accomplished through a real DOM Document as in $dom = new DOMDocument(); ...
// Here we are simply echoing the XML we want to produce (shame on me!)

// Opens a connection to a MySQL server
$connection=mysql_connect ('localhost', 'root', 'root');
if (!$connection) {  
	die('Not connected : ' . mysql_error());
};


// Set the active MySQL database
$db_selected = mysql_select_db("campus", $connection);
if (!$db_selected) {
  die ('Can\'t use db : ' . mysql_error());
} 

// This is really important otherwise output will likeby be truncated as soon as you get some accented characters
mysql_set_charset('utf8',$connection); 

// Select all the rows in the spaces table meeting some condition
$query = "SELECT id, description, AsText(g) FROM spaces WHERE 1";
$result = mysql_query($query);
if (!$result) {  
  die('Invalid query: ' . mysql_error());
}

// tell the client that this is an xml response
header("Content-type: text/xml"); 

// Generate the standard XML header for utf-8 encoding
echo "<?xml version='1.0' encoding='UTF-8'?>";

// Output the root element
echo "<Placemarks>";

// Iterate through the rows, adding XML nodes for each
while ($row = @mysql_fetch_assoc($result)){
	// Generate each placemark and appropriate attributes
  	echo '<Placemark id="'.$row['id'].'" description="'.$row['description'].'">';
	// followed by the kml string representing the wkt in the database
  	echo getGeo($row['AsText(g)']);
  	echo "</Placemark>";
} 

// Close root element
echo "</Placemarks>";

?>