declare namespace pi ="http://ssdi.di.fct.unl.pt/pi";

declare variable $pi:home :=  "file:/Users/joaomp/Desktop/Producao dados GIS - PI - 12 de Maio/"; 

declare variable $pi:campus-file := concat($pi:home, "Campus/campus-wkt-PI.xml");
declare variable $pi:citi-1-file := concat($pi:home, "CITI/citi_piso1-wkt-PI.xml");
declare variable $pi:citi-2-file := concat($pi:home, "CITI/citi_piso2-wkt-PI.xml");
declare variable $pi:citi-3-file := concat($pi:home, "CITI/citi_piso3-wkt-PI.xml");
declare variable $pi:ed1-1-file := concat($pi:home, "ED I/ed1_piso1-wkt-PI.xml");
declare variable $pi:ed1-2-file := concat($pi:home, "ED I/ed1_piso2-wkt-PI.xml");
declare variable $pi:ed2-1-file := concat($pi:home, "ED II/edII_piso1-wkt-PI.xml");
declare variable $pi:ed2-2-file := concat($pi:home, "ED II/edII_piso2-wkt-PI.xml");
declare variable $pi:ed3-0-file := concat($pi:home, "ED III/Ed_III_Piso_0-wkt-PI.xml");
declare variable $pi:ed3-1-file := concat($pi:home, "ED III/Ed_III_Piso_1-wkt-PI.xml");
declare variable $pi:ed4-0-file := concat($pi:home, "ED IV/Ed_IV_Piso_0-wkt-PI.xml");
declare variable $pi:ed4-1-file := concat($pi:home, "ED IV/Ed_IV_piso_1-wkt-PI.xml");

declare function pi:process-placemark($pl as element()) as element()
{
    <Placemark
        folder="{$pl/description/meta-information[@attribute='KML_FOLDER']/@value}"
        name="{$pl/description/meta-information[@attribute='Nome']/@value}"
        id="{$pl/description/meta-information[@attribute='ID']/@value}"
        type="{$pl/description/meta-information[@attribute='Tipo']/@value}">
    </Placemark>
};        

declare function pi:get-all-placemarks() as element()
{
    let $campus := fn:doc($pi:campus-file)//Placemark
    let $citi := ( fn:doc($pi:citi-1-file)//Placemark , fn:doc($pi:citi-2-file)//Placemark, fn:doc($pi:citi-3-file)//Placemark )
    let $ed1 := ( fn:doc($pi:ed1-1-file)//Placemark , fn:doc($pi:ed1-2-file)//Placemark )
    let $ed2 := ( fn:doc($pi:ed2-1-file)//Placemark , fn:doc($pi:ed2-2-file)//Placemark )
    let $ed3 := ( fn:doc($pi:ed3-0-file)//Placemark , fn:doc($pi:ed3-1-file)//Placemark )
    let $ed4 := ( fn:doc($pi:ed4-0-file)//Placemark , fn:doc($pi:ed4-1-file)//Placemark )

    let $all := ( $campus, $citi, $ed1, $ed2, $ed3, $ed4)
    
    return
        <Placemarks count="{count($all)}">
            {for $pl in $all
                let $pl-proc := pi:process-placemark($pl)
                order by number($pl-proc/@id)
            return $pl-proc
            }
        </Placemarks>    
};

declare function pi:duplicates() as element()
{
    <duplicates>
    {
        let $all-processed := pi:get-all-placemarks()
        for $pl in $all-processed//Placemark
        where 
            count($all-processed//Placemark[@id = $pl/@id]) gt 1.0
        return $pl
    }
    </duplicates>
};

(: This function merges the data into one element :)
declare function pi:merge () as element()
{
    let $campus := fn:doc($pi:campus-file)/*/Folder
    let $citi := ( fn:doc($pi:citi-1-file)/*/Folder , fn:doc($pi:citi-2-file)/*/Folder, fn:doc($pi:citi-3-file)/*/Folder )
    let $ed1 := ( fn:doc($pi:ed1-1-file)/*/Folder , fn:doc($pi:ed1-2-file)/*/Folder )
    let $ed2 := ( fn:doc($pi:ed2-1-file)/*/Folder , fn:doc($pi:ed2-2-file)/*/Folder )
    let $ed3 := ( fn:doc($pi:ed3-0-file)/*/Folder , fn:doc($pi:ed3-1-file)/*/Folder )
    let $ed4 := ( fn:doc($pi:ed4-0-file)/*/Folder , fn:doc($pi:ed4-1-file)/*/Folder )
    
    let $all := ( $campus, $citi, $ed1, $ed2, $ed3, $ed4)
    
    return 
        <wkt-pi>
            {$all}
        </wkt-pi>
};

pi:merge()